#include "PainterEngine_Application.h"
PX_Application App;


#define GAME_MAP_SIZE 10 //ɨ׵ͼС
#define GAME_MINE_COUNT 10 //

typedef struct  
{
	px_int  x,y;//ڰť
	px_bool isOpen;//ǰťǷ񱻵򿪹
	px_bool isMine;//ǲǵ
}PX_Cell;


PX_Cell   game_cellmap[GAME_MAP_SIZE*GAME_MAP_SIZE];
PX_Object *ui_root=PX_NULL;
PX_Object *ui_cellbutton[GAME_MAP_SIZE*GAME_MAP_SIZE];
px_shape  shape_mine;
px_bool   game_isRunning;

//////////////////////////////////////////////////////////////////////////

//
PX_Cell *PX_CELL(px_int x,px_int y)
{
	if (x<0||x>=GAME_MAP_SIZE||y<0||y>=GAME_MAP_SIZE)
	{
		return PX_NULL;
	}
	return &game_cellmap[GAME_MAP_SIZE*y+x];
}

//ɨcellΧжٸ
px_int PX_MineScan(px_int x,int y)
{
	px_int count=0;
	PX_Cell *pCell;

	//
	pCell=PX_CELL(x-1,y-1);
	count+=((pCell&&pCell->isMine)?1:0);
	pCell=PX_CELL(x,y-1);
	count+=((pCell&&pCell->isMine)?1:0);
	pCell=PX_CELL(x+1,y-1);
	count+=((pCell&&pCell->isMine)?1:0);

	//м
	pCell=PX_CELL(x-1,y);
	count+=((pCell&&pCell->isMine)?1:0);
	pCell=PX_CELL(x+1,y);
	count+=((pCell&&pCell->isMine)?1:0);

	//
	pCell=PX_CELL(x-1,y+1);
	count+=((pCell&&pCell->isMine)?1:0);
	pCell=PX_CELL(x,y+1);
	count+=((pCell&&pCell->isMine)?1:0);
	pCell=PX_CELL(x+1,y+1);
	count+=((pCell&&pCell->isMine)?1:0);

	return count;
}

//жеǲǶѾ
px_bool PX_GameIsClear()
{
	px_int i,j;
	for (j=0;j<GAME_MAP_SIZE;j++)
	{
		for (i=0;i<GAME_MAP_SIZE;i++)
		{
			//һӲǵ,ûд,ôϷҪ
			if (!PX_CELL(i,j)->isMine&&!PX_CELL(i,j)->isOpen)
			{
				return PX_FALSE;
			}
		}
	}
	return PX_TRUE;
}

//Ϸ
px_void PX_GameOver()
{
	px_int i,j;
	//ʾе
	for (j=0;j<GAME_MAP_SIZE;j++)
	{
		for (i=0;i<GAME_MAP_SIZE;i++)
		{
			if (PX_CELL(i,j)->isMine)
			{
				PX_Object_PushButtonSetShape(ui_cellbutton[i+j*GAME_MAP_SIZE],&shape_mine);
				PX_Object_PushButtonSetTextColor(ui_cellbutton[i+j*GAME_MAP_SIZE],PX_COLOR(255,255,0,0));
			}
			PX_ObjectSetEnabled(ui_cellbutton[i+j*GAME_MAP_SIZE],PX_FALSE);
		}
	}
	game_isRunning=PX_FALSE;
}

px_void PX_OnCellButtonExecute(PX_Object *pObject,PX_Object_Event e,px_void *ptr)
{
	PX_Cell *pcell=(PX_Cell *)ptr;
	
	//жϷǷ
	if (!game_isRunning) return;

	//жťǷѾ
	if (pcell->isOpen) return;

	//ǵϷ
	if (pcell->isMine)
	{
		PX_GameOver();
	}
	else
	{
		px_char content[2];
		//ɨΧ׵
		px_int count=PX_MineScan(pcell->x,pcell->y);
		
		//cellΪѡ
		pcell->isOpen=PX_TRUE;
		//cellΪɫ
		PX_ObjectSetEnabled(pObject,PX_FALSE);

		if (count==0)
		{
			PX_Cell *pTargetCell;
			PX_Object *pTargetObject;
			//ı
			PX_Object_PushButtonSetBorderColor(pObject,PX_COLOR(32,255,255,255));
			PX_Object_PushButtonSetText(pObject,"");
			
			//Χcell͵Ϣ
			//
			pTargetCell=PX_CELL(pcell->x-1,pcell->y-1);
			if (pTargetCell)
			{
				pTargetObject=ui_cellbutton[pTargetCell->x+pTargetCell->y*GAME_MAP_SIZE];
				PX_ObjectExecuteEvent(pTargetObject,PX_OBJECT_BUILD_EVENT(PX_OBJECT_EVENT_EXECUTE));
			}
			pTargetCell=PX_CELL(pcell->x,pcell->y-1);
			if (pTargetCell)
			{
				pTargetObject=ui_cellbutton[pTargetCell->x+pTargetCell->y*GAME_MAP_SIZE];
				PX_ObjectExecuteEvent(pTargetObject,PX_OBJECT_BUILD_EVENT(PX_OBJECT_EVENT_EXECUTE));
			}
			pTargetCell=PX_CELL(pcell->x+1,pcell->y-1);
			if (pTargetCell)
			{
				pTargetObject=ui_cellbutton[pTargetCell->x+pTargetCell->y*GAME_MAP_SIZE];
				PX_ObjectExecuteEvent(pTargetObject,PX_OBJECT_BUILD_EVENT(PX_OBJECT_EVENT_EXECUTE));
			}
			
			//м
			pTargetCell=PX_CELL(pcell->x-1,pcell->y);
			if (pTargetCell)
			{
				pTargetObject=ui_cellbutton[pTargetCell->x+pTargetCell->y*GAME_MAP_SIZE];
				PX_ObjectExecuteEvent(pTargetObject,PX_OBJECT_BUILD_EVENT(PX_OBJECT_EVENT_EXECUTE));
			}
			pTargetCell=PX_CELL(pcell->x+1,pcell->y);
			if (pTargetCell)
			{
				pTargetObject=ui_cellbutton[pTargetCell->x+pTargetCell->y*GAME_MAP_SIZE];
				PX_ObjectExecuteEvent(pTargetObject,PX_OBJECT_BUILD_EVENT(PX_OBJECT_EVENT_EXECUTE));
			}

			//
			pTargetCell=PX_CELL(pcell->x-1,pcell->y+1);
			if (pTargetCell)
			{
				pTargetObject=ui_cellbutton[pTargetCell->x+pTargetCell->y*GAME_MAP_SIZE];
				PX_ObjectExecuteEvent(pTargetObject,PX_OBJECT_BUILD_EVENT(PX_OBJECT_EVENT_EXECUTE));
			}
			pTargetCell=PX_CELL(pcell->x,pcell->y+1);
			if (pTargetCell)
			{
				pTargetObject=ui_cellbutton[pTargetCell->x+pTargetCell->y*GAME_MAP_SIZE];
				PX_ObjectExecuteEvent(pTargetObject,PX_OBJECT_BUILD_EVENT(PX_OBJECT_EVENT_EXECUTE));
			}
			pTargetCell=PX_CELL(pcell->x+1,pcell->y+1);
			if (pTargetCell)
			{
				pTargetObject=ui_cellbutton[pTargetCell->x+pTargetCell->y*GAME_MAP_SIZE];
				PX_ObjectExecuteEvent(pTargetObject,PX_OBJECT_BUILD_EVENT(PX_OBJECT_EVENT_EXECUTE));
			}

		}
		else
		{
			//cellı
			PX_itoa(count,content,2,10);
			PX_Object_PushButtonSetBorderColor(pObject,PX_COLOR(96,255,255,255));
			PX_Object_PushButtonSetText(pObject,content);
		}

		if (PX_GameIsClear())
		{
			PX_GameOver();
		}
	}
	
}



//////////////////////////////////////////////////////////////////////////
//ʼϷ
px_void PX_GameInitialize()
{
	px_int i,j;

	//ʼͼ
	PX_memset(game_cellmap,0,sizeof(game_cellmap));

	//ɾ֮ǰİť
	if (ui_root)
	{
		PX_ObjectDelete(ui_root);
	}
	//
	ui_root=PX_ObjectCreate(&App.runtime.mp_ui,PX_NULL,0,0,0,0,0,0);

	//ť
	for (j=0;j<GAME_MAP_SIZE;j++)
	{
		for (i=0;i<GAME_MAP_SIZE;i++)
		{
			ui_cellbutton[i+j*GAME_MAP_SIZE]=PX_Object_PushButtonCreate(&App.runtime.mp_ui,ui_root,i*21,j*21,20,20,"?",PX_NULL);
			PX_ObjectRegisterEvent(ui_cellbutton[i+j*GAME_MAP_SIZE],PX_OBJECT_EVENT_EXECUTE,PX_OnCellButtonExecute,&game_cellmap[i+j*GAME_MAP_SIZE]);
		}
	}

	//ʼͼ
	for (j=0;j<GAME_MAP_SIZE;j++)
	{
		for (i=0;i<GAME_MAP_SIZE;i++)
		{
			game_cellmap[i+j*GAME_MAP_SIZE].x=i;
			game_cellmap[i+j*GAME_MAP_SIZE].y=j;
			game_cellmap[i+j*GAME_MAP_SIZE].isMine=PX_FALSE;
			game_cellmap[i+j*GAME_MAP_SIZE].isOpen=PX_FALSE;
		}
	}

	//ѡGAME_MINE_COUNTcellΪ
	i=0;
	while (i<GAME_MINE_COUNT)
	{
		px_int index=(px_int)PX_randRange(0,GAME_MAP_SIZE*GAME_MAP_SIZE);
		if(!game_cellmap[index].isMine)
		{
			game_cellmap[index].isMine=PX_TRUE;
			i++;
		}
	}

	//ʼϷ
	game_isRunning=PX_TRUE;
}

px_bool PX_ApplicationInitialize(PX_Application *pApp,px_int screen_width,px_int screen_height)
{
	PX_ApplicationInitializeDefault(&pApp->runtime, screen_width, screen_height);
	PX_LoadShapeFromFile(&pApp->runtime.mp_resources,&shape_mine,"mine.traw");
	PX_GameInitialize();

	return PX_TRUE;
}

px_void PX_ApplicationUpdate(PX_Application *pApp,px_dword elpased)
{
	
}

px_void PX_ApplicationRender(PX_Application *pApp,px_dword elpased)
{
	px_surface *pRenderSurface=&pApp->runtime.RenderSurface;
	PX_RuntimeRenderClear(&pApp->runtime,PX_OBJECT_UI_DEFAULT_BACKGROUNDCOLOR);
	PX_ObjectRender(pRenderSurface,ui_root,elpased);
}

px_void PX_ApplicationPostEvent(PX_Application *pApp,PX_Object_Event e)
{
	PX_ApplicationEventDefault(&pApp->runtime, e);
	PX_ObjectPostEvent(ui_root,e);

}

